org.apache.hc.core5.http

## Interface HttpEntity

- All Superinterfaces:
    AutoCloseable, Closeable, EntityDetails
  All Known Implementing Classes:
    AbstractHttpEntity, BasicHttpEntity, BufferedHttpEntity, ByteArrayEntity, ByteBufferEntity, EntityTemplate, FileEntity, HttpEntityWrapper, InputStreamEntity, NullEntity, PathEntity, SerializableEntity, StringEntity

      public interface HttpEntity
      extends EntityDetails, Closeable

  An entity that can be sent or received with an HTTP message.

  There are three distinct types of entities in HttpCore, depending on where their `content` originates:

  - streamed: The content is received from a stream, or generated on the fly. In particular, this category includes entities being received from a `connection`. `Streamed` entities are generally not `repeatable`.
  - self-contained: The content is in memory or obtained by means that are independent from a connection or other entity. Self-contained entities are generally `repeatable`.
  - wrapping: The content is obtained from another entity.

  This distinction is important for connection management with incoming entities. For entities that are created by an application and only sent using the HTTP components framework, the difference between streamed and self-contained is of little importance. In that case, it is suggested to consider non-repeatable entities as streamed, and those that are repeatable (without a huge effort) as self-contained.

  Since:
    4.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `InputStream` | `getContent()` Gets a content stream of the entity.
    `Supplier<List<? extends Header>>` | `getTrailers()` Gets supplier of message trailers - headers sent after message body.
    `boolean` | `isRepeatable()` Tests if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tests whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes the entity content out to the output stream.

    - ### Methods inherited from interface org.apache.hc.core5.http.EntityDetails

      `getContentEncoding, getContentLength, getContentType, getTrailerNames, isChunked`

    - ### Methods inherited from interface java.io.Closeable

      `close`

- - ### Method Detail

    - #### isRepeatable

          boolean isRepeatable()

      Tests if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### getContent

          InputStream getContent()
                          throws IOException,
                                 UnsupportedOperationException

      Gets a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
        `UnsupportedOperationException` - if entity content cannot be represented as `InputStream`.
      See Also:
        `isRepeatable()`

    - #### writeTo

          void writeTo(OutputStream outStream)
                throws IOException

      Writes the entity content out to the output stream.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

      Parameters:
        `outStream` - the output stream to write entity content to
      Throws:
        `IOException` - if an I/O error occurs

    - #### isStreaming

          boolean isStreaming()

      Tests whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### getTrailers

          Supplier<List<? extends Header>> getTrailers()

      Gets supplier of message trailers - headers sent after message body. May return `null` if trailers are not available.
      Since:
        5.0

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.